// C Source File
// Created 26/06/03; 14:14:53

// Seven Tiles 0.52 beta

#include "globals.h"

void _main(void)
{

short g,x,y;
short player_coords[4];
unsigned long randnum=255-peekIO(0x600017);


#ifndef _fargo
void * buffer = NULL;					// buffer for the D-Buffering
	if (!AMS_1xx) randnum+=(*((volatile unsigned long*)(_rom_call_addr(4FC))))*(_GrayIsRealHW2()?52:78);
#else
//HANDLE hd;
	choosescreen = 1;
#endif

	srand(randnum);

	#ifndef _fargo
	while(!main_menu())    // loop while the user didn't choose CANCEL at the main menu
	{
		if(!(buffer = malloc(GRAYDBUFFER_SIZE)))  return;  // allocates the buffer for double buffering
 		#else
 		main_menu();
 		//if(!(hd = HeapAlloc(GRAYDBUFFER_SIZE)))  return;  // allocates the buffer for double buffering
		//buffer = DEREF( hd );
 		#endif

		SaveAndReplaceInts();  				// inhibate ints 1,2 and 5

		if(GrayOn())
		{

	 		player_coords[0]=player_coords[1]=player_coords[2]=player_coords[3]=g=x=y=0;

 			#ifndef _fargo
			GrayDBufInit(buffer);											// init D-Buffering
			FontSetSys (CALCULATOR?F_8x10:F_6x8);			// set font size to medium
			#else
  		clr_scr(gray4lib__plane0);
  		clr_scr(gray4lib__plane1);
			FontSetSys ( 2 );
			#endif

			fill_table();          										// fill the table with values from 0 to 6

			do
			{
				draw_table(x,y);          // draw all colored tiles with zone separators

				#ifndef _fargo
				GrayDBufToggleSync();     // D-Buffering
				#endif

				if(!winner_check()) break;	// exit if someone has won

				if(!(player == PLAYER2 && game_type == PLAYER_VS_AI))					// human player
				{
					g=wait_a_key();		// wait for a key

					if(K_ENTER)								// if enter (or lock or something ...)
						if(!game_menu())				// switch player if the menu didn't return an escape code
						{
							player_coords[2*player] = x;
							player_coords[2*player+1] = y;		// save coords
							player = (player+1)&1;						// switch players

							if(game_type == PLAYER_VS_PLAYER)
	 						{
								x = player_coords[2*player];						// don't switch coords in 1 player game
								y = player_coords[2*player+1];
							}
						}

					if(K_LEFT && (x<5))  x++;			// change coords to scroll the grid
					if(K_RIGHT && (x+TABLE_WIDTH>0))	x--;
					if(K_DOWN && (y+(TABLE_HEIGHT>>1)>0))  y--;
					if(K_UP && (y<5))    y++;
				}
				else					// play AI
				{
					AI_do();
					player = PLAYER1;			// switch to player 1 (since AI is always player 2)
				}

			} while(!K_ESC);

			wait_no_key();

			GrayOff();      	// return to black & white mode
		}

		RestoreInts(); 		// restores ints 1,2 and 5

		#ifndef _fargo
		free(buffer);			// free the double buffering buffer
		ClrScr();					// clear the screen (and return to the first menu then)
	}
	  #else
    //HeapFree(hd);
    #endif


}
