// C Source File
// Created 27/06/03; 01:17:43

#include "globals.h"

static void draw_box(void * plane0,void * plane1)
{
unsigned short y;

	for(y=480;y--;)
		*(short*)(plane1+2*y)=*(short*)(plane0+2*y)=(y<(15*31) && y>29)?0x0000:0xFFFF;

	#ifndef _fargo
	GrayDBufSetActiveAMSPlane(DARK_PLANE);
	#endif

	printf_xy(2,5,"Player 1:%2d%%%sPlayer 2:%2d%%",total[PLAYER1],CALCULATOR?" - \0":"-\0",total[PLAYER2]);

}

short game_menu(void)
{
short g,i,j;

#ifndef _fargo
void * plane0 = GrayDBufGetActivePlane(LIGHT_PLANE);
void * plane1 = GrayDBufGetActivePlane(DARK_PLANE);
#else
void * plane0 = gray4lib__plane0;
void * plane1 = gray4lib__plane1;
#endif
	g=j=0;

	while(j==player_color[PLAYER1] || j==player_color[PLAYER2]) j++;
	wait_no_key();

	while(42)
	{
		draw_box(plane0,plane1);

		printf_xy((CALCULATOR?7:9)+(CALCULATOR?30:20)*j,18,"%c",26);
		printf_xy(0,Ymax-10,"Player %d",player+1);
		for(i=7;i--;(player_color[PLAYER1]!=i && player_color[PLAYER2]!=i)?CustomSprite16x15_or(15+(CALCULATOR?30:20)*i,15,i,plane0,plane1):0);

		g=wait_a_key();
		wait_no_key();

		if(K_ESC) return 1;
		if(K_ENTER)
		{
			color = (unsigned char)j;
			expand();	// calculates the expansion
			return 0;
		}

		do{

			if(K_LEFT)	j--;
			if(K_RIGHT)	j++;
			if(j>6)			j=0;
			if(j<0)			j=6;

		} while(j==player_color[PLAYER1] || j==player_color[PLAYER2]);
	}
}

short winner_check(void)
{
short maxtot = (TABLE_HEIGHT*((TABLE_WIDTH<<1)-1))>>1;

#ifndef _fargo
void * plane0 = GrayDBufGetActivePlane(LIGHT_PLANE);
void * plane1 = GrayDBufGetActivePlane(DARK_PLANE);
#else
void * plane0 = gray4lib__plane0;
void * plane1 = gray4lib__plane1;
#endif

	total[PLAYER1] = (total[PLAYER1]*100)/maxtot;
	total[PLAYER2] = (total[PLAYER2]*100)/maxtot;

	if(total[PLAYER1]<50 && total[PLAYER2]<50) return 1;

	draw_box(plane0,plane1);
	printf_xy(CALCULATOR?62:32,20,"Player %d wins !",(total[PLAYER1]>=50)?1:2);

	wait_a_key();

	return 0;
}

short main_menu(void)	// main menu
{
static short menu_defaults[3] = {2,2,1};        // medium, medium, 1 player

#ifndef _fargo

HANDLE dialoghd = DialogNewSimple(CALCULATOR?200:140,CALCULATOR?80:70);
HANDLE popuphd_list[3];    // creates 3 popups
short i,index;
char * ptr;
static const char s1[] = "1 Player";
static const char s2[] = "2 Players";
static const char s3[] = "Low";
static const char s4[] = "Medium";
static const char s5[] = "High";
static const char s6[] = "Little";
static const char s7[] = "Great";
static const char * menu_str[3][4] = {{s3,s4,s5,NULL},{s6,s4,s7,NULL},{s1,s2,NULL,NULL}};
static const char menu_txt_92[3][18] = {{"Fragmentation....\0"},{"Size.............\0"},{"Game type........\0"}};
static const char menu_txt_89[3][28] = {{"Fragmentation ...\0"},{"Size ....................\0"},{"Game type .........\0"}};



  DialogAddTitle(dialoghd,"Seven Tiles",BT_OK,BT_CANCEL);
  DialogAddText(dialoghd,6,12,"Sevent Tiles: enter settings");

  for(index=3;index--;)
  {
    popuphd_list[index]=PopupNew(NULL,i=0);
    while((ptr=(char*)menu_str[index][i++])) PopupAddText(popuphd_list[index],-1,ptr,i);      // while the string's not null, add it to the current popup
    DialogAddPulldown(dialoghd,21,40-8*(index)+1,CALCULATOR?menu_txt_92[index]:menu_txt_89[index],popuphd_list[index],index);  // add a pulldown
  }

  index=DialogDo(dialoghd,CENTER,CENTER,NULL,menu_defaults);  // display the dialog

  HeapFree(dialoghd);                      // free the dialog's handle
  for(i=3;i--;HeapFree(popuphd_list[i]));  // free the popups' handles

#endif

  fragmentation = menu_defaults[FRAG]-1;  // set the global vars to the selected values
  TABLE_WIDTH = 9+4*(menu_defaults[SIZE]);
  TABLE_HEIGHT = 9+4*(menu_defaults[SIZE]);
	game_type = menu_defaults[TYPE];

#ifndef _fargo
  return (index==KEY_ESC);
#else
	return 0;
#endif
}

